//	-------------------------------------------------------------------------
//
//	DIALOG.HPP
//
//	-------------------------------------------------------------------------
//
//	AUTHOR:			Darren J. Dwyer
//
//	DESCRIPTION:	this file contains the definition for a standard
//					Dialog Box
//
//	-------------------------------------------------------------------------

#ifndef __dialog_hpp
#define __dialog_hpp

#include "event.hpp"
#include "handler.hpp"
#include "accessry.hpp"

//	-------------------------------------------------------------------------
//
//	CLASS:	DialogBox
//
//	DESC:   This is the basic dialog box object which allows simple access
//			to "pop-up" windows. An examples of a dialog box is the
//			FileDialogBox
//
//	-------------------------------------------------------------------------

class DialogBox : public EventHandler
	{
	protected:
		int				prev_zfactor;	// the previous zfactor
		uint			prev_handler;	// the previously selected handler
		uint 			handler_num;	// the [evhno_] number of this handler
		uint			parent_handler;	// the [evhno_] number of the handler
										// which responds to returnEvent

	public:
		DialogBox(int x1,int y1,int x2,int y2,uchar fg,uchar bg,
						uint active_border,uint inactive_border,
						uint dialog_num,uint parent_handler_num,
						uint options,uint zfact,uint retevent);

		virtual void OpenDialog();		// opens the dialog box
		virtual void CloseDialog();		// closes the dialog box

		virtual void HandleEvent(Event &e);	// the handleevent function
	};

#endif

