//
//	REALMODE.HPP - Issues a real-mode interrupt from protected mode
//	using DPMI call 300h.
//
//	Note that any buffers to be passed to DOS _must_ be allocated in DOS memory.
//  This can be done with DPMI call 100h. (refer WATCOM\SRC\GOODIES\SIMULATE.C)
//

#ifndef __realmode_hpp
#define __realmode_hpp

#include "i86.h"

#define DPMI_int	0x31		// the DPMI interrupt number

struct rminfo
	{
	long EDI;
	long ESI;
	long EBP;
	long reserved_by_system;
	long EBX;
	long EDX;
	long ECX;
	long EAX;
	short flags;
	short ES,DS,FS,GS,IP,CS,SP,SS;
	};

#define HIWORD(X)		( ((unsigned long)(X)) >> 16 )
#define LOWORD(X)		( ((unsigned long)(X)) & 0xFFFF )

// return real-mode segment & offsets
#define	RM_FP_SEG(P)	( (((unsigned long) (P)) >> 4) & 0xFFFF )
#define	RM_FP_OFF(P)	( ((unsigned long) (P)) & 0xF )

// return protected-mode ptr for real-mode SEG:OFS pair
#define RM_MK_FP(S,O)    ( (char far*) \
							((((S) & 0xFFFF) << 4) \
							+  ( (O) & 0xFFFF )) \
							)

// allocates 'bytes' bytes from Real Mode DOS memory
void far* RM_malloc(short* selector,short* segment,unsigned bytes);
// frees the Real Mode DOS memory allocated with RM_malloc()
void RM_free(short selector);

// generate a real-mode interrupt from protected mode (same as BC int86,int86x)
void RM_int86(int intno, union REGS *inregs, union REGS *outregs);
void RM_int86x(int intno, union REGS *inregs, union REGS *outregs,struct SREGS* ionsregs);

#endif